Index: soft/giet_vm/giet_libs/stdio.c
===================================================================
--- soft/giet_vm/giet_libs/stdio.c	(revision 709)
+++ soft/giet_vm/giet_libs/stdio.c	(revision 713)
@@ -111,35 +111,35 @@
 }
 
-//////////////////////////////////////////////
-int giet_pthread_pause( char*     vspace_name,
-                        char*     thread_name )
-{
-    return sys_call( SYSCALL_PTHREAD_CONTROL,
-                     THREAD_CMD_PAUSE,
-                     (unsigned int) vspace_name,
-                     (unsigned int) thread_name,
-                     0 );
-}
-
-///////////////////////////////////////////////
-int giet_pthread_resume( char*     vspace_name,
-                         char*     thread_name )
-{
-    return sys_call( SYSCALL_PTHREAD_CONTROL,
-                     THREAD_CMD_RESUME,
-                     (unsigned int) vspace_name,
-                     (unsigned int) thread_name,
-                     0 );
-}
-
-///////////////////////////////////////////////
-int giet_pthread_context( char*     vspace_name,
-                          char*     thread_name )
-{
-    return sys_call( SYSCALL_PTHREAD_CONTROL,
-                     THREAD_CMD_CONTEXT,
-                     (unsigned int) vspace_name,
-                     (unsigned int) thread_name,
-                     0 );
+////////////////////////////////////////////////
+void giet_pthread_control( unsigned int command,  
+                           char*        vspace_name,
+                           char*        thread_name )
+{
+    int ret = sys_call( SYSCALL_PTHREAD_CONTROL,
+                        command,
+                        (unsigned int) vspace_name,
+                        (unsigned int) thread_name,
+                        0 );
+
+    if ( ret == SYSCALL_VSPACE_NOT_FOUND )
+    {
+        giet_tty_printf("  ERROR in PTHREAD_CONTROL : "
+                        "vspace %s not found\n", vspace_name );
+    }
+    if ( ret == SYSCALL_THREAD_NOT_FOUND )
+    {
+        giet_tty_printf("  ERROR in PTHREAD_CONTROL : "
+                        "thread %s not found\n", thread_name );
+    }
+    if ( ret == SYSCALL_UNCOHERENT_THREAD_CONTEXT )
+    {
+        giet_tty_printf("  ERROR in PTHREAD_CONTROL : "
+                        "uncoherent context for thread %s\n", thread_name );
+    }
+    if ( ret == SYSCALL_ILLEGAL_THREAD_COMMAND_TYPE )
+    {
+        giet_tty_printf("  ERROR in PTHREAD_CONTROL : "
+                        "illegal command type %d\n", command );
+    }
 }
 
@@ -165,9 +165,10 @@
 }
 
-///////////////////////////////
-void giet_applications_status()
+///////////////////////////////////////////
+void giet_applications_status( char* name )
 {
     sys_call( SYSCALL_APPS_STATUS,
-              0, 0, 0, 0 );
+              (unsigned int)name,
+              0, 0, 0 );
 }
 
@@ -776,5 +777,5 @@
 {
     if ( sys_call( SYSCALL_TIM_ALLOC,
-                   0, 0, 0, 0 ) ) giet_pthread_exit("error in giet_timer_alloc()");
+                   0, 0, 0, 0 ) ) giet_pthread_exit("ERROR in TIMER_ALLOC");
 }
 
@@ -784,5 +785,5 @@
     if ( sys_call( SYSCALL_TIM_START,
                    period,
-                   0, 0, 0 ) ) giet_pthread_exit("error in giet_timer_start()");
+                   0, 0, 0 ) ) giet_pthread_exit("ERROR in TIMER_START");
 }
 
@@ -791,5 +792,5 @@
 {
     if ( sys_call( SYSCALL_TIM_STOP,
-                   0, 0, 0, 0 ) ) giet_pthread_exit("error in giet_timer_stop()");
+                   0, 0, 0, 0 ) ) giet_pthread_exit("ERROR in TIMER_STOP");
 }
 
@@ -799,9 +800,26 @@
 //////////////////////////////////////////////////////////////////////////////////
 
+////////////////////////////////////////
+void giet_fbf_size( unsigned int* width,
+                    unsigned int* height )
+{
+    sys_call( SYSCALL_FBF_SIZE,
+              (unsigned int)width,
+              (unsigned int)height,
+              0, 0 );
+}
+                    
+/////////////////////
+void giet_fbf_alloc()
+{
+    if ( sys_call( SYSCALL_FBF_ALLOC, 
+                   0, 0, 0, 0 ) )    giet_pthread_exit("ERROR in FBF_ALLOC");
+}
+
 /////////////////////////
 void giet_fbf_cma_alloc()
 {
     if ( sys_call( SYSCALL_FBF_CMA_ALLOC, 
-                   0, 0, 0, 0 ) )    giet_pthread_exit("error in giet_fbf_cma_alloc()");
+                   0, 0, 0, 0 ) )    giet_pthread_exit("ERROR in FBF_CMA_ALLOC");
 }
 
@@ -816,5 +834,5 @@
                    (unsigned int)buf1_vbase,
                    (unsigned int)sts0_vaddr, 
-                   (unsigned int)sts1_vaddr ) )   giet_pthread_exit("error in giet_fbf_cma_init_buf()");
+                   (unsigned int)sts1_vaddr ) ) giet_pthread_exit("ERROR in FBF_CMA_INIT_BUF");
 }
 
@@ -824,5 +842,5 @@
     if ( sys_call( SYSCALL_FBF_CMA_START,
                    length, 
-                   0, 0, 0 ) )   giet_pthread_exit("error in giet_fbf_cma_start()");
+                   0, 0, 0 ) )   giet_pthread_exit("ERROR in FBF_CMA_START");
 }
 
@@ -832,5 +850,5 @@
     if ( sys_call( SYSCALL_FBF_CMA_DISPLAY,
                    buffer, 
-                   0, 0, 0 ) )   giet_pthread_exit("error in giet_fbf_cma_display()");
+                   0, 0, 0 ) )   giet_pthread_exit("ERROR in FBF_CMA_DISPLAY");
 }
 
@@ -839,5 +857,5 @@
 {
     if ( sys_call( SYSCALL_FBF_CMA_STOP, 
-                   0, 0, 0, 0 ) )    giet_pthread_exit("error in giet_fbf_cma_stop()");
+                   0, 0, 0, 0 ) )    giet_pthread_exit("ERROR in FBF_CMA_STOP");
 }
 
@@ -851,5 +869,5 @@
                    (unsigned int)buffer, 
                    length, 
-                   0 ) )  giet_pthread_exit("error in giet_fbf_sync_write()");
+                   0 ) )  giet_pthread_exit("ERROR in FBF_SYNC_WRITE");
 }
 
@@ -863,5 +881,5 @@
                    (unsigned int)buffer, 
                    length, 
-                   0 ) )   giet_pthread_exit("error in giet_fbf_sync_read()");
+                   0 ) )   giet_pthread_exit("ERROR in FBF_SYNC_READ");
 }
 